SystemOrganization addCategory: #GODEmail!

Object subclass: #GMReceiver
	instanceVariableNames: 'hostname password user'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GODEmail'!

!GMReceiver class methodsFor: 'instance creation' stamp: 'LFSA 9/28/2014 11:46'!
connectTo: hostname identifiedAs: user password: password
	^(((self new hostname: hostname) user: user) password: password)! !

!GMReceiver methodsFor: 'accessing' stamp: 'LFSA 9/28/2014 11:31'!
hostname
	^hostname! !

!GMReceiver methodsFor: 'accessing' stamp: 'LFSA 9/28/2014 11:30'!
hostname: aString
	hostname := aString! !

!GMReceiver methodsFor: 'initialize-release' stamp: 'LFSA 9/28/2014 17:07'!
initialize
	self initializeConnectionInfo.! !

!GMReceiver methodsFor: 'initialize-release' stamp: 'LFSA 9/28/2014 17:08'!
initializeConnectionInfo
	hostname := ''.
	user := ''.
	password := ''.! !

!GMReceiver methodsFor: 'accessing' stamp: 'LFSA 9/28/2014 11:31'!
password: aString
	password := aString! !

!GMReceiver methodsFor: 'actions' stamp: 'LFSA 9/28/2014 15:47'!
receive
	"Connects to the server, receives new emails and converts them into a list of GodData"
	self validateConnectionInfo.
	^OrderedCollection new.! !

!GMReceiver methodsFor: 'accessing' stamp: 'LFSA 9/28/2014 11:31'!
user
	^user! !

!GMReceiver methodsFor: 'accessing' stamp: 'LFSA 9/28/2014 11:31'!
user: aString
	user := aString! !

!GMReceiver methodsFor: 'private' stamp: 'LFSA 9/28/2014 17:06'!
validateConnectionInfo
	hostname isEmpty
		ifTrue: [^Error signal: 'Hostname value is empty'].

	user isEmpty
		ifTrue: [^Error signal: 'User value is empty'].
	
	password isEmpty
		ifTrue: [^Error signal: 'Password value is empty'].! !

Object subclass: #GMSender
	instanceVariableNames: 'hostname password user'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GODEmail'!

!GMSender class methodsFor: 'instance creation' stamp: 'LFSA 9/28/2014 11:46'!
connectTo: hostname identifiedAs: user password: password
	^(((self new hostname: hostname) user: user) password: password)! !

!GMSender methodsFor: 'accessing' stamp: 'LFSA 9/28/2014 11:30'!
hostname
	^hostname! !

!GMSender methodsFor: 'accessing' stamp: 'LFSA 9/28/2014 11:28'!
hostname: aString
	hostname := aString! !

!GMSender methodsFor: 'initialize-release' stamp: 'LFSA 9/28/2014 17:08'!
initialize
	self initializeConnectionInfo.! !

!GMSender methodsFor: 'initialize-release' stamp: 'LFSA 9/28/2014 17:08'!
initializeConnectionInfo
	hostname := ''.
	user := ''.
	password := ''.! !

!GMSender methodsFor: 'accessing' stamp: 'LFSA 9/28/2014 11:29'!
password: aString
	password := aString! !

!GMSender methodsFor: 'actions' stamp: 'LFSA 9/28/2014 15:36'!
send: data to: recipient
	"Sends the GODData contained in data to recipient (a string with an email address)"
	self validateConnectionInfo.
	^true.! !

!GMSender methodsFor: 'accessing' stamp: 'LFSA 9/28/2014 11:30'!
user
	^user! !

!GMSender methodsFor: 'accessing' stamp: 'LFSA 9/28/2014 11:30'!
user: aString
	user := aString! !

!GMSender methodsFor: 'private' stamp: 'LFSA 9/28/2014 17:06'!
validateConnectionInfo
	hostname isEmpty
		ifTrue: [^Error signal: 'Hostname value is empty'].

	user isEmpty
		ifTrue: [^Error signal: 'User value is empty'].
	
	password isEmpty
		ifTrue: [^Error signal: 'Password value is empty'].! !
